import java.util.Vector;

import javax.bluetooth.BluetoothStateException;
import javax.bluetooth.DeviceClass;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.DiscoveryListener;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

public class BTInquiry implements DiscoveryListener, CommandListener {

	private  DiscoveryAgent discoveryAgent;
    public  Vector devices = new Vector();
    public  Vector records = new Vector();
    private  Object prevScreen = new Object();
    private List devicesList = new List(null,List.IMPLICIT);
	Command cmdSelect = new Command("Select", Command.OK, 1);
	Command cmdBack = new Command("Back", Command.BACK, 2);
	private Display display;
	
	UUID[] uuidSet;
	int[] attrSet;
    
    private boolean BTReady;
	
    BTInquiry(Display display) {
    	this.display = display;
    }
    
    public void startInquiry(){
    	prevScreen = display.getCurrent();
    	display.setCurrent(devicesList);
    	new Thread(){public void run(){
    		inquiryDevices();
    		} 
    	}.start();
    }
    
    private void informError(String msg){
        Alert al = new Alert("Error", msg, null, AlertType.ERROR);
        al.setTimeout(1000);
        display.setCurrent(al, display.getCurrent());
    }
    
    
    private synchronized void inquiryDevices(){
		
		BTReady = false;
		try {
            LocalDevice localDevice = LocalDevice.getLocalDevice();
            discoveryAgent = localDevice.getDiscoveryAgent();
            BTReady = true;
        } catch (Exception e) {
        	informError("Can't initialize bluetooth: " + e);
        }
        
        if (BTReady){
        	
            devicesList.deleteAll();
        	devicesList.setTitle("Searching...");
        	devicesList.setCommandListener(this);
        	
            //Inquiry
            devices.removeAllElements();
        	try {
                discoveryAgent.startInquiry(DiscoveryAgent.GIAC, this);
            } catch (BluetoothStateException e) {
            	informError("Can't start inquiry");
            }
            
        	try {
                wait();
            } catch (InterruptedException e) {
            	informError("Unknown error");
            }
 
        }
        
	}
	
	
    public void deviceDiscovered(RemoteDevice btDevice, DeviceClass cod) {

        if (devices.indexOf(btDevice) == -1) {
            devices.addElement(btDevice);
        }
        devicesList.append(btDevice.getBluetoothAddress(),null);
    }
	
    private void backToMScreen(){
    	display.setCurrent((Displayable)prevScreen);
    }
    
    private void noDevices(){
    	informError("No devices have been found :(");
    	backToMScreen();
    }
    
    public void inquiryCompleted(int discType) {
    	if (devices.size() == 0) noDevices();	
    	else {
    		new Thread(){public void run(){searchServices();}}.start();
    	}
    }
    
    public void commandAction(Command c, Displayable d) {
    	if (c == cmdSelect){
	    	if (devices.size() != 0){
	        	int index = devicesList.getSelectedIndex();
	        	String url = ((ServiceRecord)records.elementAt(index)).getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT,false);
	        	BTRadio.bturl = url;
	        	Settings.setParam("bturl",url);
	        	devicesList.append("fuck", null);
	        	devicesList.append(url, null);
	        	backToMScreen();
	    	} 
    	} else if (c == cmdBack){
    		backToMScreen();
    	}
    }
    
    public synchronized void  searchServices(){
		
		devicesList.deleteAll();
    	records.removeAllElements();
		uuidSet = new UUID[]{new UUID("F0E0D0C0B0A000908070605040302010", false)};
    	//uuidSet = new UUID[]{new UUID(256)};
    	attrSet = new int[] {0x4321};
		
		devicesList.setTitle("Searching services...");
        
        for (int i = 0; i < devices.size(); i++) {
        	RemoteDevice RD = (RemoteDevice)devices.elementAt(i);
        	try {
                discoveryAgent.searchServices(null, uuidSet, RD, this);
                wait();
            } catch (BluetoothStateException e) {
                continue;
            } catch (InterruptedException e) {
                continue;
            }
        }
        try{Thread.sleep(2000);} catch (InterruptedException e){};
        backToMScreen();
	}

    public void servicesDiscovered(int transID, ServiceRecord[] servRecord) {
    	for (int i = 0; i < servRecord.length; i++) {
            records.addElement(servRecord[i]);
            devicesList.append(((ServiceRecord)records.elementAt(i)).getHostDevice().getBluetoothAddress(),null);
        }
    }
    
    public void serviceSearchCompleted(int transID, int respCode) {
    	devicesList.setTitle("Search completed.");
    	devicesList.addCommand(cmdBack);
    	devicesList.addCommand(cmdSelect);
    	for (int i = 0; i < records.size(); i++) {
			String deviceName = ((ServiceRecord)records.elementAt(i)).getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT,false);
			devicesList.set(i, deviceName ,null);
    	}
    }
    
}
